/*
 * Scratchpad MMU - Conventional scratchpad manager for some global vars.
 * Copyright (C) Jack Whitham 2009
 * http://www.jwhitham.org.uk/c/smmu.html
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation
 * (version 2.1 of the License only).
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */
#include <string.h>
#include "drvif.h"

Stack _open_stack __attribute__((section(".spad")));
Activity_Record _ar_start [ MAX_AR_ID ] __attribute__((section(".spad")));
Activity_Record _ar_id [ MAX_AR_ID ] __attribute__((section(".spad")));
unsigned activate_smmu __attribute__((section(".spad")));

extern void * __spad_start ;
extern void * __spad_end ;

void Zero_Spad ( void )
{
    unsigned    begin = (unsigned) & __spad_start ;
    unsigned    end = (unsigned) & __spad_end ;
    unsigned    scmd = (* ((unsigned *) begin )) ;

    /* reset memory space */
    memset ( (void *) begin , 0 , end - begin ) ;
    /* command from the simulator? */
    if (( scmd & 0xffffff00UL ) == 0x5e5e5e00 )
    {
        activate_smmu = scmd & 0xff ;
    } else {
        activate_smmu = 0xff ;
    }
}

